git-rebase.shon commit rebase: introduce and use pseudo-ref REBASE_HEAD (fbd7a23)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27f,force-rebase!    force rebase even if branch is up to date
  28X,strategy-option=! pass the argument through to the merge strategy
  29stat!              display a diffstat of what changed upstream
  30n,no-stat!         do not show diffstat of what changed upstream
  31verify             allow pre-rebase hook to run
  32rerere-autoupdate  allow rerere to update index with resolved conflicts
  33root!              rebase all reachable commits up to the root(s)
  34autosquash         move commits that begin with squash!/fixup! under -i
  35committer-date-is-author-date! passed to 'git am'
  36ignore-date!       passed to 'git am'
  37signoff            passed to 'git am'
  38whitespace=!       passed to 'git apply'
  39ignore-whitespace! passed to 'git apply'
  40C=!                passed to 'git apply'
  41S,gpg-sign?        GPG-sign commits
  42 Actions:
  43continue!          continue
  44abort!             abort and check out the original branch
  45skip!              skip current patch and continue
  46edit-todo!         edit the todo list during an interactive rebase
  47quit!              abort but keep HEAD where it is
  48show-current-patch! show the patch file being applied or merged
  49"
  50. git-sh-setup
  51set_reflog_action rebase
  52require_work_tree_exists
  53cd_to_toplevel
  54
  55LF='
  56'
  57ok_to_skip_pre_rebase=
  58resolvemsg="
  59$(gettext 'Resolve all conflicts manually, mark them as resolved with
  60"git add/rm <conflicted_files>", then run "git rebase --continue".
  61You can instead skip this commit: run "git rebase --skip".
  62To abort and get back to the state before "git rebase", run "git rebase --abort".')
  63"
  64unset onto
  65unset restrict_revision
  66cmd=
  67strategy=
  68strategy_opts=
  69do_merge=
  70merge_dir="$GIT_DIR"/rebase-merge
  71apply_dir="$GIT_DIR"/rebase-apply
  72verbose=
  73diffstat=
  74test "$(git config --bool rebase.stat)" = true && diffstat=t
  75autostash="$(git config --bool rebase.autostash || echo false)"
  76fork_point=auto
  77git_am_opt=
  78git_format_patch_opt=
  79rebase_root=
  80force_rebase=
  81allow_rerere_autoupdate=
  82# Non-empty if a rebase was in progress when 'git rebase' was invoked
  83in_progress=
  84# One of {am, merge, interactive}
  85type=
  86# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  87state_dir=
  88# One of {'', continue, skip, abort}, as parsed from command line
  89action=
  90preserve_merges=
  91autosquash=
  92keep_empty=
  93test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  94case "$(git config --bool commit.gpgsign)" in
  95true)   gpg_sign_opt=-S ;;
  96*)      gpg_sign_opt= ;;
  97esac
  98
  99read_basic_state () {
 100        test -f "$state_dir/head-name" &&
 101        test -f "$state_dir/onto" &&
 102        head_name=$(cat "$state_dir"/head-name) &&
 103        onto=$(cat "$state_dir"/onto) &&
 104        # We always write to orig-head, but interactive rebase used to write to
 105        # head. Fall back to reading from head to cover for the case that the
 106        # user upgraded git with an ongoing interactive rebase.
 107        if test -f "$state_dir"/orig-head
 108        then
 109                orig_head=$(cat "$state_dir"/orig-head)
 110        else
 111                orig_head=$(cat "$state_dir"/head)
 112        fi &&
 113        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 114        test -f "$state_dir"/verbose && verbose=t
 115        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 116        test -f "$state_dir"/strategy_opts &&
 117                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 118        test -f "$state_dir"/allow_rerere_autoupdate &&
 119                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 120        test -f "$state_dir"/gpg_sign_opt &&
 121                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 122}
 123
 124write_basic_state () {
 125        echo "$head_name" > "$state_dir"/head-name &&
 126        echo "$onto" > "$state_dir"/onto &&
 127        echo "$orig_head" > "$state_dir"/orig-head &&
 128        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 129        test t = "$verbose" && : > "$state_dir"/verbose
 130        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 131        test -n "$strategy_opts" && echo "$strategy_opts" > \
 132                "$state_dir"/strategy_opts
 133        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 134                "$state_dir"/allow_rerere_autoupdate
 135        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 136}
 137
 138output () {
 139        case "$verbose" in
 140        '')
 141                output=$("$@" 2>&1 )
 142                status=$?
 143                test $status != 0 && printf "%s\n" "$output"
 144                return $status
 145                ;;
 146        *)
 147                "$@"
 148                ;;
 149        esac
 150}
 151
 152move_to_original_branch () {
 153        case "$head_name" in
 154        refs/*)
 155                message="rebase finished: $head_name onto $onto"
 156                git update-ref -m "$message" \
 157                        $head_name $(git rev-parse HEAD) $orig_head &&
 158                git symbolic-ref \
 159                        -m "rebase finished: returning to $head_name" \
 160                        HEAD $head_name ||
 161                die "$(eval_gettext "Could not move back to \$head_name")"
 162                ;;
 163        esac
 164}
 165
 166apply_autostash () {
 167        if test -f "$state_dir/autostash"
 168        then
 169                stash_sha1=$(cat "$state_dir/autostash")
 170                if git stash apply $stash_sha1 >/dev/null 2>&1
 171                then
 172                        echo "$(gettext 'Applied autostash.')" >&2
 173                else
 174                        git stash store -m "autostash" -q $stash_sha1 ||
 175                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 176                        gettext 'Applying autostash resulted in conflicts.
 177Your changes are safe in the stash.
 178You can run "git stash pop" or "git stash drop" at any time.
 179' >&2
 180                fi
 181        fi
 182}
 183
 184finish_rebase () {
 185        rm -f "$(git rev-parse --git-path REBASE_HEAD)"
 186        apply_autostash &&
 187        { git gc --auto || true; } &&
 188        rm -rf "$state_dir"
 189}
 190
 191run_specific_rebase () {
 192        if [ "$interactive_rebase" = implied ]; then
 193                GIT_EDITOR=:
 194                export GIT_EDITOR
 195                autosquash=
 196        fi
 197        . git-rebase--$type
 198        ret=$?
 199        if test $ret -eq 0
 200        then
 201                finish_rebase
 202        elif test $ret -eq 2 # special exit status for rebase -i
 203        then
 204                apply_autostash &&
 205                rm -rf "$state_dir" &&
 206                die "Nothing to do"
 207        fi
 208        exit $ret
 209}
 210
 211run_pre_rebase_hook () {
 212        if test -z "$ok_to_skip_pre_rebase" &&
 213           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 214        then
 215                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 216                die "$(gettext "The pre-rebase hook refused to rebase.")"
 217        fi
 218}
 219
 220test -f "$apply_dir"/applying &&
 221        die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
 222
 223if test -d "$apply_dir"
 224then
 225        type=am
 226        state_dir="$apply_dir"
 227elif test -d "$merge_dir"
 228then
 229        if test -f "$merge_dir"/interactive
 230        then
 231                type=interactive
 232                interactive_rebase=explicit
 233        else
 234                type=merge
 235        fi
 236        state_dir="$merge_dir"
 237fi
 238test -n "$type" && in_progress=t
 239
 240total_argc=$#
 241while test $# != 0
 242do
 243        case "$1" in
 244        --no-verify)
 245                ok_to_skip_pre_rebase=yes
 246                ;;
 247        --verify)
 248                ok_to_skip_pre_rebase=
 249                ;;
 250        --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
 251                test $total_argc -eq 2 || usage
 252                action=${1##--}
 253                ;;
 254        --onto=*)
 255                onto="${1#--onto=}"
 256                ;;
 257        --exec=*)
 258                cmd="${cmd}exec ${1#--exec=}${LF}"
 259                test -z "$interactive_rebase" && interactive_rebase=implied
 260                ;;
 261        --interactive)
 262                interactive_rebase=explicit
 263                ;;
 264        --keep-empty)
 265                keep_empty=yes
 266                ;;
 267        --preserve-merges)
 268                preserve_merges=t
 269                test -z "$interactive_rebase" && interactive_rebase=implied
 270                ;;
 271        --autosquash)
 272                autosquash=t
 273                ;;
 274        --no-autosquash)
 275                autosquash=
 276                ;;
 277        --fork-point)
 278                fork_point=t
 279                ;;
 280        --no-fork-point)
 281                fork_point=
 282                ;;
 283        --merge)
 284                do_merge=t
 285                ;;
 286        --strategy-option=*)
 287                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 288                do_merge=t
 289                test -z "$strategy" && strategy=recursive
 290                ;;
 291        --strategy=*)
 292                strategy="${1#--strategy=}"
 293                do_merge=t
 294                ;;
 295        --no-stat)
 296                diffstat=
 297                ;;
 298        --stat)
 299                diffstat=t
 300                ;;
 301        --autostash)
 302                autostash=true
 303                ;;
 304        --no-autostash)
 305                autostash=false
 306                ;;
 307        --verbose)
 308                verbose=t
 309                diffstat=t
 310                GIT_QUIET=
 311                ;;
 312        --quiet)
 313                GIT_QUIET=t
 314                git_am_opt="$git_am_opt -q"
 315                verbose=
 316                diffstat=
 317                ;;
 318        --whitespace=*)
 319                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 320                case "${1#--whitespace=}" in
 321                fix|strip)
 322                        force_rebase=t
 323                        ;;
 324                esac
 325                ;;
 326        --ignore-whitespace)
 327                git_am_opt="$git_am_opt $1"
 328                ;;
 329        --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
 330                git_am_opt="$git_am_opt $1"
 331                force_rebase=t
 332                ;;
 333        -C*)
 334                git_am_opt="$git_am_opt $1"
 335                ;;
 336        --root)
 337                rebase_root=t
 338                ;;
 339        --force-rebase|--no-ff)
 340                force_rebase=t
 341                ;;
 342        --rerere-autoupdate|--no-rerere-autoupdate)
 343                allow_rerere_autoupdate="$1"
 344                ;;
 345        --gpg-sign)
 346                gpg_sign_opt=-S
 347                ;;
 348        --gpg-sign=*)
 349                gpg_sign_opt="-S${1#--gpg-sign=}"
 350                ;;
 351        --)
 352                shift
 353                break
 354                ;;
 355        *)
 356                usage
 357                ;;
 358        esac
 359        shift
 360done
 361test $# -gt 2 && usage
 362
 363if test -n "$action"
 364then
 365        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 366        # Only interactive rebase uses detailed reflog messages
 367        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 368        then
 369                GIT_REFLOG_ACTION="rebase -i ($action)"
 370                export GIT_REFLOG_ACTION
 371        fi
 372fi
 373
 374if test "$action" = "edit-todo" && test "$type" != "interactive"
 375then
 376        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 377fi
 378
 379case "$action" in
 380continue)
 381        # Sanity check
 382        git rev-parse --verify HEAD >/dev/null ||
 383                die "$(gettext "Cannot read HEAD")"
 384        git update-index --ignore-submodules --refresh &&
 385        git diff-files --quiet --ignore-submodules || {
 386                echo "$(gettext "You must edit all merge conflicts and then
 387mark them as resolved using git add")"
 388                exit 1
 389        }
 390        read_basic_state
 391        run_specific_rebase
 392        ;;
 393skip)
 394        output git reset --hard HEAD || exit $?
 395        read_basic_state
 396        run_specific_rebase
 397        ;;
 398abort)
 399        git rerere clear
 400        read_basic_state
 401        case "$head_name" in
 402        refs/*)
 403                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 404                die "$(eval_gettext "Could not move back to \$head_name")"
 405                ;;
 406        esac
 407        output git reset --hard $orig_head
 408        finish_rebase
 409        exit
 410        ;;
 411quit)
 412        exec rm -rf "$state_dir"
 413        ;;
 414edit-todo)
 415        run_specific_rebase
 416        ;;
 417show-current-patch)
 418        run_specific_rebase
 419        die "BUG: run_specific_rebase is not supposed to return here"
 420        ;;
 421esac
 422
 423# Make sure no rebase is in progress
 424if test -n "$in_progress"
 425then
 426        state_dir_base=${state_dir##*/}
 427        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 428        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 429        die "
 430$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 431I wonder if you are in the middle of another rebase.  If that is the
 432case, please try
 433        $cmd_live_rebase
 434If that is not the case, please
 435        $cmd_clear_stale_rebase
 436and run me again.  I am stopping in case you still have something
 437valuable there.')"
 438fi
 439
 440if test -n "$rebase_root" && test -z "$onto"
 441then
 442        test -z "$interactive_rebase" && interactive_rebase=implied
 443fi
 444
 445if test -n "$interactive_rebase"
 446then
 447        type=interactive
 448        state_dir="$merge_dir"
 449elif test -n "$do_merge"
 450then
 451        type=merge
 452        state_dir="$merge_dir"
 453else
 454        type=am
 455        state_dir="$apply_dir"
 456fi
 457
 458if test -t 2 && test -z "$GIT_QUIET"
 459then
 460        git_format_patch_opt="$git_format_patch_opt --progress"
 461fi
 462
 463if test -z "$rebase_root"
 464then
 465        case "$#" in
 466        0)
 467                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 468                        --verify -q @{upstream} 2>/dev/null)
 469                then
 470                        . git-parse-remote
 471                        error_on_missing_default_upstream "rebase" "rebase" \
 472                                "against" "git rebase $(gettext '<branch>')"
 473                fi
 474
 475                test "$fork_point" = auto && fork_point=t
 476                ;;
 477        *)      upstream_name="$1"
 478                if test "$upstream_name" = "-"
 479                then
 480                        upstream_name="@{-1}"
 481                fi
 482                shift
 483                ;;
 484        esac
 485        upstream=$(peel_committish "${upstream_name}") ||
 486        die "$(eval_gettext "invalid upstream '\$upstream_name'")"
 487        upstream_arg="$upstream_name"
 488else
 489        if test -z "$onto"
 490        then
 491                empty_tree=$(git hash-object -t tree /dev/null)
 492                onto=$(git commit-tree $empty_tree </dev/null)
 493                squash_onto="$onto"
 494        fi
 495        unset upstream_name
 496        unset upstream
 497        test $# -gt 1 && usage
 498        upstream_arg=--root
 499fi
 500
 501# Make sure the branch to rebase onto is valid.
 502onto_name=${onto-"$upstream_name"}
 503case "$onto_name" in
 504*...*)
 505        if      left=${onto_name%...*} right=${onto_name#*...} &&
 506                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 507        then
 508                case "$onto" in
 509                ?*"$LF"?*)
 510                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 511                        ;;
 512                '')
 513                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 514                        ;;
 515                esac
 516        else
 517                die "$(eval_gettext "\$onto_name: there is no merge base")"
 518        fi
 519        ;;
 520*)
 521        onto=$(peel_committish "$onto_name") ||
 522        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 523        ;;
 524esac
 525
 526# If the branch to rebase is given, that is the branch we will rebase
 527# $branch_name -- branch/commit being rebased, or HEAD (already detached)
 528# $orig_head -- commit object name of tip of the branch before rebasing
 529# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 530switch_to=
 531case "$#" in
 5321)
 533        # Is it "rebase other $branchname" or "rebase other $commit"?
 534        branch_name="$1"
 535        switch_to="$1"
 536
 537        # Is it a local branch?
 538        if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
 539           orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
 540        then
 541                head_name="refs/heads/$branch_name"
 542        # If not is it a valid ref (branch or commit)?
 543        elif orig_head=$(git rev-parse -q --verify "$branch_name")
 544        then
 545                head_name="detached HEAD"
 546
 547        else
 548                die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
 549        fi
 550        ;;
 5510)
 552        # Do not need to switch branches, we are already on it.
 553        if branch_name=$(git symbolic-ref -q HEAD)
 554        then
 555                head_name=$branch_name
 556                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 557        else
 558                head_name="detached HEAD"
 559                branch_name=HEAD
 560        fi
 561        orig_head=$(git rev-parse --verify HEAD) || exit
 562        ;;
 563*)
 564        die "BUG: unexpected number of arguments left to parse"
 565        ;;
 566esac
 567
 568if test "$fork_point" = t
 569then
 570        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 571                        "${switch_to:-HEAD}")
 572        if test -n "$new_upstream"
 573        then
 574                restrict_revision=$new_upstream
 575        fi
 576fi
 577
 578if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 579then
 580        stash_sha1=$(git stash create "autostash") ||
 581        die "$(gettext 'Cannot autostash')"
 582
 583        mkdir -p "$state_dir" &&
 584        echo $stash_sha1 >"$state_dir/autostash" &&
 585        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 586        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 587        git reset --hard
 588fi
 589
 590require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 591
 592# Now we are rebasing commits $upstream..$orig_head (or with --root,
 593# everything leading up to $orig_head) on top of $onto
 594
 595# Check if we are already based on $onto with linear history,
 596# but this should be done only when upstream and onto are the same
 597# and if this is not an interactive rebase.
 598mb=$(git merge-base "$onto" "$orig_head")
 599if test "$type" != interactive && test "$upstream" = "$onto" &&
 600        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 601        # linear history?
 602        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 603then
 604        if test -z "$force_rebase"
 605        then
 606                # Lazily switch to the target branch if needed...
 607                test -z "$switch_to" ||
 608                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 609                        git checkout -q "$switch_to" --
 610                if test "$branch_name" = "HEAD" &&
 611                         ! git symbolic-ref -q HEAD
 612                then
 613                        say "$(eval_gettext "HEAD is up to date.")"
 614                else
 615                        say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 616                fi
 617                finish_rebase
 618                exit 0
 619        else
 620                if test "$branch_name" = "HEAD" &&
 621                         ! git symbolic-ref -q HEAD
 622                then
 623                        say "$(eval_gettext "HEAD is up to date, rebase forced.")"
 624                else
 625                        say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 626                fi
 627        fi
 628fi
 629
 630# If a hook exists, give it a chance to interrupt
 631run_pre_rebase_hook "$upstream_arg" "$@"
 632
 633if test -n "$diffstat"
 634then
 635        if test -n "$verbose"
 636        then
 637                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 638        fi
 639        # We want color (if set), but no pager
 640        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 641fi
 642
 643test "$type" = interactive && run_specific_rebase
 644
 645# Detach HEAD and reset the tree
 646say "$(gettext "First, rewinding head to replay your work on top of it...")"
 647
 648GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 649        git checkout -q "$onto^0" || die "could not detach HEAD"
 650git update-ref ORIG_HEAD $orig_head
 651
 652# If the $onto is a proper descendant of the tip of the branch, then
 653# we just fast-forwarded.
 654if test "$mb" = "$orig_head"
 655then
 656        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 657        move_to_original_branch
 658        finish_rebase
 659        exit 0
 660fi
 661
 662if test -n "$rebase_root"
 663then
 664        revisions="$onto..$orig_head"
 665else
 666        revisions="${restrict_revision-$upstream}..$orig_head"
 667fi
 668
 669run_specific_rebase